"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var useScriptLoader_1 = __importDefault(require("./hooks/useScriptLoader"));
var useSafeState_1 = __importDefault(require("./hooks/useSafeState"));
var ScriptLoaderContext = (0, react_1.createContext)({
    loaderStatus: "loading",
});
var noop = function () {
    //intentionally empty
};
var ScriptLoader = function (_a) {
    var source = _a.source, _b = _a.onSuccess, onSuccess = _b === void 0 ? noop : _b, _c = _a.onError, onError = _c === void 0 ? noop : _c, props = __rest(_a, ["source", "onSuccess", "onError"]);
    var _d = __read((0, useSafeState_1.default)(false), 2), isSucceeded = _d[0], setIsSucceeded = _d[1];
    var _e = __read((0, useSafeState_1.default)(false), 2), isFailed = _e[0], setIsFailed = _e[1];
    var loaderStatus = (0, react_1.useMemo)(function () {
        if (isSucceeded)
            return "succeeded";
        if (isFailed)
            return "failed";
        return "loading";
    }, [isSucceeded, isFailed]);
    var onLoaderSuccess = (0, react_1.useCallback)(function () {
        setIsSucceeded(true);
        setIsFailed(false);
        onSuccess();
    }, [onSuccess, setIsSucceeded, setIsFailed]);
    var onLoaderFailure = (0, react_1.useCallback)(function (err) {
        setIsFailed(true);
        setIsSucceeded(false);
        onError(err);
    }, [onError, setIsSucceeded, setIsFailed]);
    (0, useScriptLoader_1.default)({
        source: source,
        onSuccess: onLoaderSuccess,
        onFailure: onLoaderFailure,
    });
    return react_1.default.createElement(ScriptLoaderContext.Provider, __assign({ value: { loaderStatus: loaderStatus } }, props));
};
var Success = function (_a) {
    var children = _a.children;
    var loaderStatus = (0, react_1.useContext)(ScriptLoaderContext).loaderStatus;
    return loaderStatus === "succeeded" ? react_1.default.createElement(react_1.default.Fragment, null, children) : react_1.default.createElement(react_1.default.Fragment, null);
};
var Failed = function (_a) {
    var children = _a.children;
    var loaderStatus = (0, react_1.useContext)(ScriptLoaderContext).loaderStatus;
    return loaderStatus === "failed" ? react_1.default.createElement(react_1.default.Fragment, null, children) : react_1.default.createElement(react_1.default.Fragment, null);
};
var Loading = function (_a) {
    var children = _a.children;
    var loaderStatus = (0, react_1.useContext)(ScriptLoaderContext).loaderStatus;
    return loaderStatus === "loading" ? react_1.default.createElement(react_1.default.Fragment, null, children) : react_1.default.createElement(react_1.default.Fragment, null);
};
ScriptLoader.Success = Success;
ScriptLoader.Failed = Failed;
ScriptLoader.Loading = Loading;
exports.default = ScriptLoader;
