"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var scriptloader_support_1 = require("../scriptloader-support");
exports.default = (function useScriptLoader(config) {
    var _this = this;
    var source = config.source, onSuccess = config.onSuccess, _a = config.onFailure, onFailure = _a === void 0 ? function () {
        //noop
    } : _a, configAttributes = config.scriptAttributes;
    var _b = __read((0, react_1.useState)(configAttributes), 2), scriptAttributes = _b[0], setScriptAttributes = _b[1];
    var isMounted = (0, react_1.useRef)(true);
    (0, react_1.useEffect)(function () { return function () {
        isMounted.current = false;
    }; }, []);
    var successFunc = (0, react_1.useCallback)(function () { return isMounted.current && onSuccess(); }, [onSuccess]);
    var errorFunc = (0, react_1.useCallback)(function (err) { return isMounted.current && onFailure(err); }, [onFailure]);
    (0, react_1.useEffect)(function () {
        setScriptAttributes(function (oldAttrs) {
            if (Boolean(oldAttrs) !== Boolean(configAttributes)) {
                return configAttributes;
            }
            if (!oldAttrs) {
                return oldAttrs;
            }
            var oldEntries = Object.entries(oldAttrs);
            var newEntries = Object.entries(configAttributes);
            if (oldEntries.length !== newEntries.length) {
                return configAttributes;
            }
            if (oldEntries.some(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                return configAttributes[key] !== value;
            })) {
                return configAttributes;
            }
            return oldAttrs;
        });
    }, [configAttributes]);
    (0, react_1.useEffect)(function () {
        var waitForSource = function () { return __awaiter(_this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, (0, scriptloader_support_1.waitForScript)(source, scriptAttributes)];
                    case 1:
                        _a.sent();
                        successFunc();
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        errorFunc(err_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        void waitForSource();
    }, [source, successFunc, errorFunc, scriptAttributes]);
});
