"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitForScript = void 0;
var scriptCache_1 = require("../scriptCache");
var waitForScript = function (source, scriptAttributes) {
    return new Promise(function (resolve, reject) {
        var updater = function (_a) {
            var loading = _a.loading, failed = _a.failed, failureEvent = _a.failureEvent;
            if (!loading && !failed) {
                resolve();
                (0, scriptCache_1.removeScriptUpdater)(source, updater);
            }
            if (!loading && failed) {
                reject(failureEvent);
                (0, scriptCache_1.removeScriptUpdater)(source, updater);
            }
        };
        var cachedScriptInfo = (0, scriptCache_1.retrieveCachedScript)(source, scriptAttributes);
        if (!cachedScriptInfo.loading) {
            updater(cachedScriptInfo);
        }
        else {
            (0, scriptCache_1.addScriptUpdater)(source, updater);
        }
    });
};
exports.waitForScript = waitForScript;
