import { useState, useCallback, useRef, useEffect, } from "react";
export default function useSafeState(initial) {
    const [state, setState] = useState(initial);
    const mountedRef = useRef(true);
    const safeSetState = useCallback((newVal) => {
        if (mountedRef.current) {
            return setState(newVal);
        }
    }, []);
    useEffect(() => () => {
        mountedRef.current = false;
    }, []);
    return [state, safeSetState];
}
