import { addScriptUpdater, removeScriptUpdater, retrieveCachedScript, } from "../scriptCache";
export const waitForScript = (source, scriptAttributes) => new Promise((resolve, reject) => {
    const updater = ({ loading, failed, failureEvent }) => {
        if (!loading && !failed) {
            resolve();
            removeScriptUpdater(source, updater);
        }
        if (!loading && failed) {
            reject(failureEvent);
            removeScriptUpdater(source, updater);
        }
    };
    const cachedScriptInfo = retrieveCachedScript(source, scriptAttributes);
    if (!cachedScriptInfo.loading) {
        updater(cachedScriptInfo);
    }
    else {
        addScriptUpdater(source, updater);
    }
});
